/**
 *
 * Copyright (C) 2013, 2014 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef BLOCK_SORTING_H
#define BLOCK_SORTING_H

#include "bases.h"
#include "sf.h"
#include "bits.h"

#define MAX_BUFFER_SIZE 1000000 // Taille maximal des blocks lus
#define TCHAR_SIZE 256 //Taille de Tchar
#define COPY_BUFFER_SIZE 1024 //Taille du buffer pour la copie de fichier
#define DEFAULT_BLOCK_SIZE 100000 //Taille du block lu par défaut

typedef unsigned char Tchar ;

Tchar* bufferBlock ; //Tableau buffer pour qsort
int bufferSize ; //taille du buffer pour qsort

/**
 * Fonctions principale du block sorting
 */
void blockSort( Tchar* data, int size, int* resultRow, Tchar** result) ;
void blockSortReverse(Tchar* data, int size, int resultRow, Tchar** result) ;

void moveToFront(FILE* in, FILE* out) ;
void moveToFrontReverse(FILE* in, FILE* out) ;

void rle(FILE* in, FILE* out) ;
void rleReverse(FILE* in, FILE* out) ;

void rle2(FILE* in, FILE* out) ;
void rleReverse2(FILE* in, FILE* out) ;

void blockSorting(FILE* in, FILE* out,
		  unsigned int maxBlockSize, int rlea, int matrice) ;
void blockSortingReverse(FILE* in, FILE* out, int rlea, int matrice) ;

/**
 * Utilitaires
 */
void fill(int* tab, int size, int value) ;
void initTab(int* tab, int size) ;
int compareStr (const void *arg1, const void *arg2) ;
int compareTChar (const void *arg1, const void *arg2) ;
int compareIndices(const void *arg1, const void *arg2) ;
void fcopy(FILE* in, FILE* out) ;
unsigned int filesize(FILE* f) ;

/**
 * Version de base lente (matrices)
 */
Tchar** allocation_matrice_carree_char(int nbe) ;
void liberation_matrice_carree_char(Tchar **table, int nbe) ;
void affiche_matrice_carree(int nbe, Tchar **a, FILE* f) ;
void blockSortMatrice( Tchar* data, int size, int* resultRow, Tchar** result) ;
void blockSortReverseMatrice(Tchar* data, int size,
			     int resultRow, Tchar** result) ;



#endif
