#include "bit.h"

/*
 * Retourne le nombre de bits utilis pour coder l'entier
 * Voici quelques chiffres :
 * v=0 --> 0 bit  car sa reprsentation binaire est : ""
 * v=1 --> 1 bit  car sa reprsentation binaire est : "1"
 * v=2 --> 2 bits car sa reprsentation binaire est : "10"
 * v=3 --> 2 bits car sa reprsentation binaire est : "11"
 * v=4 --> 3 bits car sa reprsentation binaire est : "100"
 *
 * (Vous perdez des points de TP si vous utilisez une fonction travaillant
 * avec des nombres flottants)
 */

unsigned int nb_bits_utile(unsigned long v)
{
  unsigned int nb_bits = 0 ;
  if( v ){
    nb_bits = nb_bits_utile( v >> 1 ) ;
    nb_bits ++ ;
  }
  return nb_bits ; 
}

/*
 * Cette fonction retourne un entier ne contenant qu'un seul bit  1.
 * La position de ce bit a 1 est indiqu par le paramtre.
 *
 *  Position   Valeur binaire   Valeur decimale
 *     0       0...00000001           1
 *     1       0...00000010           2
 *     .       ............          ..
 *     7       0...10000000         128
 *     .       ............        ....
 *     .       ............        ....
 *
 * La choix de numrotation de droite  gauche t faite car
 * la numrotation des bits ne change pas en fonction de la taille de l'entier.
 *
 * En fait, cette fonction est quivalente  "pow(2,position)"
 * (Vous perdez des points de TP si vous utilisez une fonction travaillant
 * avec des nombres flottants)
 */

unsigned long pow2(Position_Bit position)
{
  return 1uL << position ;
  /*
  unsigned long resultat = 1 ;
  for ( ; position > 0 ; position--){
    resultat *= 2 ;
  }  
  return resultat ;*/
}

/*
 * Cette fonction retourne le bit "n" d'un entier.
 * La valeur retourne sera un boolen : Vrai ou Faux
 *
 * prend_bit(2,0) ==> 0
 * prend_bit(2,1) ==> 1
 * prend_bit(2,2) ==> 0
 */

Booleen prend_bit(unsigned long c,	     /* L'entier o on prend le bit */
		  Position_Bit position	     /* La position du bit pris */
		  )
{
  unsigned long p = pow2(position) ;
  return (c & p) != 0 ;
}

/*
 * Idem pour le stockage, on stocke la valeur "bit"  la position indique.
 * Si "bit" est  Faux            on met le bit  0
 * Si "bit" est diffrent de Faux on met le bit  1
 */

unsigned long pose_bit(unsigned long c,	      /* Entier  modifier */
		       Position_Bit position, /* Position du bit  modifi */
		       Booleen      bit	      /* Nouvelle valeur du bit */
		       )
{
  unsigned long p = pow2(position) ;
  c = bit ? c |  p
          : c & ~p ;
  return c ;
}
